public inbox for fstests@vger.kernel.org
 help / color / mirror / Atom feed
From: Xiong Zhou <xzhou@redhat.com>
To: fstests@vger.kernel.org
Cc: eguan@redhat.com, Xiong Zhou <xzhou@redhat.com>
Subject: [PATCH] overlay: test basic whiteout
Date: Thu, 21 Apr 2016 20:23:58 +0800	[thread overview]
Message-ID: <1461241438-24238-1-git-send-email-xzhou@redhat.com> (raw)

Overlayfs whiteout can be visible if underlying xfs was created
with ftype=0. Kernel commit
	45aebea (ovl: Ensure upper filesystem supports d_type)
prevents mounting overlayfs like this since v4.6-rc1. No harm to
keep this test as a sanity check.

Signed-off-by: Xiong Zhou <xzhou@redhat.com>
---
 tests/overlay/003     | 78 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/overlay/003.out |  2 ++
 tests/overlay/group   |  1 +
 3 files changed, 81 insertions(+)
 create mode 100755 tests/overlay/003
 create mode 100644 tests/overlay/003.out

diff --git a/tests/overlay/003 b/tests/overlay/003
new file mode 100755
index 0000000..2401075
--- /dev/null
+++ b/tests/overlay/003
@@ -0,0 +1,78 @@
+#! /bin/bash
+# FS QA Test 003
+#
+# Test overlayfs whiteout.
+#
+# Overlayfs whiteout can be visible if underlying xfs was created
+# with ftype=0. Kernel commit
+#	45aebea (ovl: Ensure upper filesystem supports d_type)
+# prevents mounting overlayfs like this since v4.6-rc1. No harm to
+# keep this test as a sanity check.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016 Red Hat Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs overlay
+_supported_os Linux
+_require_scratch
+
+# Remove all files from previous tests
+_scratch_mkfs
+
+# Create test file in lower dir
+lowerdir=${SCRATCH_DEV}/${OVERLAY_LOWER_DIR}
+mkdir -p $lowerdir
+touch ${lowerdir}/test_file
+
+_scratch_mount
+
+# whiteout file in overlay mount
+rm -f ${SCRATCH_MNT}/test_file
+# it should not be listed
+ls -l ${SCRATCH_MNT}/test_file 2>&1 | awk -F: '{print $NF}'
+
+_scratch_unmount
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/003.out b/tests/overlay/003.out
new file mode 100644
index 0000000..83bafee
--- /dev/null
+++ b/tests/overlay/003.out
@@ -0,0 +1,2 @@
+QA output created by 003
+ No such file or directory
diff --git a/tests/overlay/group b/tests/overlay/group
index 84d164e..f671c67 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -5,3 +5,4 @@
 #
 001 auto quick copyup
 002 auto quick metadata
+003 auto quick
-- 
2.5.5


             reply	other threads:[~2016-04-21 12:24 UTC|newest]

Thread overview: 14+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2016-04-21 12:23 Xiong Zhou [this message]
2016-04-21 12:57 ` [PATCH] overlay: test basic whiteout Eryu Guan
2016-04-21 13:15   ` Xiong Zhou
2016-04-22  8:11   ` [PATCH 1/2] " Xiong Zhou
2016-04-22  8:11     ` [PATCH 2/2] overlay: notrun if upper fs does not support d_type Xiong Zhou
2016-04-22  9:21       ` [PATCH v2] " Xiong Zhou
2016-04-22 10:24         ` Eryu Guan
2016-04-22 10:09     ` [PATCH 1/2] overlay: test basic whiteout Eryu Guan
2016-05-04  6:53 ` [PATCH] overlay: test copy up by changing mode bits Xiong Zhou
2016-05-04  9:26   ` Eryu Guan
2016-05-09  4:12 ` [PATCH] overlay: test memleak in copy up error handling path Xiong Zhou
2016-05-10  2:32   ` [PATCH v2] overlay: test memleak in copy-up " Xiong Zhou
2016-05-26  7:24     ` Eryu Guan
2016-05-27  5:46       ` Xiong Zhou

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1461241438-24238-1-git-send-email-xzhou@redhat.com \
    --to=xzhou@redhat.com \
    --cc=eguan@redhat.com \
    --cc=fstests@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox